----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    11:13:14 04/30/2010 
-- Design Name: 
-- Module Name:    LUT_ADDR_RF_TOP - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity LUT_ADDR_RF_TOP is
    Port ( clk : in  STD_LOGIC;
           iter_id : in  STD_LOGIC_VECTOR (3 downto 0);
           arg_id : in  STD_LOGIC_VECTOR (3 downto 0);
			  bitin : in STD_LOGIC;
           lut_addr_11 : out  STD_LOGIC_VECTOR (10 downto 0));
end LUT_ADDR_RF_TOP;

architecture Behavioral of LUT_ADDR_RF_TOP is

signal lutv1,lutv2,lutv3,lutv4,lutv5,lutv6,lutv7,lutv8,lutv9,lutv10,lutv11,lutv12, lut_f: std_logic_vector(10 downto 0):=(others=>'0');


component MUX12to1_11 is
    Port ( sel : in  STD_LOGIC_VECTOR (3 downto 0);
           val1 : in  STD_LOGIC_VECTOR (10 downto 0);
           val2 : in  STD_LOGIC_VECTOR (10 downto 0);
           val3 : in  STD_LOGIC_VECTOR (10 downto 0);
           val4 : in  STD_LOGIC_VECTOR (10 downto 0);
           val5 : in  STD_LOGIC_VECTOR (10 downto 0);
           val6 : in  STD_LOGIC_VECTOR (10 downto 0);
           val7 : in  STD_LOGIC_VECTOR (10 downto 0);
           val8 : in  STD_LOGIC_VECTOR (10 downto 0);
           val9 : in  STD_LOGIC_VECTOR (10 downto 0);
           val10 : in  STD_LOGIC_VECTOR (10 downto 0);
           val11 : in  STD_LOGIC_VECTOR (10 downto 0);
           val12 : in  STD_LOGIC_VECTOR (10 downto 0);
           val_o : out  STD_LOGIC_VECTOR (10 downto 0));
end component;

component shift_reg_11b_10c is
  port (
    clk : in STD_LOGIC := 'X'; 
    d : in STD_LOGIC_VECTOR ( 10 downto 0 ); 
    q : out STD_LOGIC_VECTOR ( 10 downto 0 ) 
  );
end component;


begin

process(clk)
begin
if clk'event and clk='1' then
	if iter_id="0001" then
		if arg_id="0000" then
			lutv1(10)<=bitin;
		elsif arg_id="0001" then
			lutv2(10)<=bitin;
		elsif arg_id="0010" then
			lutv3(10)<=bitin;
		elsif arg_id="0011" then
			lutv4(10)<=bitin;
		elsif arg_id="0100" then
			lutv5(10)<=bitin;
		elsif arg_id="0101" then
			lutv6(10)<=bitin;
		elsif arg_id="0110" then
			lutv7(10)<=bitin;
		elsif arg_id="0111" then
			lutv8(10)<=bitin;
		elsif arg_id="1000" then
			lutv9(10)<=bitin;
		elsif arg_id="1001" then
			lutv10(10)<=bitin;
		elsif arg_id="1010" then
			lutv11(10)<=bitin;
		else
			lutv12(10)<=bitin;
		end if;
	elsif iter_id="0010" then
		if arg_id="0000" then
			lutv1(9)<=bitin;
		elsif arg_id="0001" then
			lutv2(9)<=bitin;
		elsif arg_id="0010" then
			lutv3(9)<=bitin;
		elsif arg_id="0011" then
			lutv4(9)<=bitin;
		elsif arg_id="0100" then
			lutv5(9)<=bitin;
		elsif arg_id="0101" then
			lutv6(9)<=bitin;
		elsif arg_id="0110" then
			lutv7(9)<=bitin;
		elsif arg_id="0111" then
			lutv8(9)<=bitin;
		elsif arg_id="1000" then
			lutv9(9)<=bitin;
		elsif arg_id="1001" then
			lutv10(9)<=bitin;
		elsif arg_id="1010" then
			lutv11(9)<=bitin;
		else
			lutv12(9)<=bitin;
		end if;
	elsif iter_id="0011" then
		if arg_id="0000" then
			lutv1(8)<=bitin;
		elsif arg_id="0001" then
			lutv2(8)<=bitin;
		elsif arg_id="0010" then
			lutv3(8)<=bitin;
		elsif arg_id="0011" then
			lutv4(8)<=bitin;
		elsif arg_id="0100" then
			lutv5(8)<=bitin;
		elsif arg_id="0101" then
			lutv6(8)<=bitin;
		elsif arg_id="0110" then
			lutv7(8)<=bitin;
		elsif arg_id="0111" then
			lutv8(8)<=bitin;
		elsif arg_id="1000" then
			lutv9(8)<=bitin;
		elsif arg_id="1001" then
			lutv10(8)<=bitin;
		elsif arg_id="1010" then
			lutv11(8)<=bitin;
		else
			lutv12(8)<=bitin;
		end if;
	elsif iter_id="0100" then
		if arg_id="0000" then
			lutv1(7)<=bitin;
		elsif arg_id="0001" then
			lutv2(7)<=bitin;
		elsif arg_id="0010" then
			lutv3(7)<=bitin;
		elsif arg_id="0011" then
			lutv4(7)<=bitin;
		elsif arg_id="0100" then
			lutv5(7)<=bitin;
		elsif arg_id="0101" then
			lutv6(7)<=bitin;
		elsif arg_id="0110" then
			lutv7(7)<=bitin;
		elsif arg_id="0111" then
			lutv8(7)<=bitin;
		elsif arg_id="1000" then
			lutv9(7)<=bitin;
		elsif arg_id="1001" then
			lutv10(7)<=bitin;
		elsif arg_id="1010" then
			lutv11(7)<=bitin;
		else
			lutv12(7)<=bitin;
		end if;
	elsif iter_id="0101" then
		if arg_id="0000" then
			lutv1(6)<=bitin;
		elsif arg_id="0001" then
			lutv2(6)<=bitin;
		elsif arg_id="0010" then
			lutv3(6)<=bitin;
		elsif arg_id="0011" then
			lutv4(6)<=bitin;
		elsif arg_id="0100" then
			lutv5(6)<=bitin;
		elsif arg_id="0101" then
			lutv6(6)<=bitin;
		elsif arg_id="0110" then
			lutv7(6)<=bitin;
		elsif arg_id="0111" then
			lutv8(6)<=bitin;
		elsif arg_id="1000" then
			lutv9(6)<=bitin;
		elsif arg_id="1001" then
			lutv10(6)<=bitin;
		elsif arg_id="1010" then
			lutv11(6)<=bitin;
		else
			lutv12(6)<=bitin;
		end if;
	elsif iter_id="0110" then
		if arg_id="0000" then
			lutv1(5)<=bitin;
		elsif arg_id="0001" then
			lutv2(5)<=bitin;
		elsif arg_id="0010" then
			lutv3(5)<=bitin;
		elsif arg_id="0011" then
			lutv4(5)<=bitin;
		elsif arg_id="0100" then
			lutv5(5)<=bitin;
		elsif arg_id="0101" then
			lutv6(5)<=bitin;
		elsif arg_id="0110" then
			lutv7(5)<=bitin;
		elsif arg_id="0111" then
			lutv8(5)<=bitin;
		elsif arg_id="1000" then
			lutv9(5)<=bitin;
		elsif arg_id="1001" then
			lutv10(5)<=bitin;
		elsif arg_id="1010" then
			lutv11(5)<=bitin;
		else
			lutv12(5)<=bitin;
		end if;
	elsif iter_id="0111" then
		if arg_id="0000" then
			lutv1(4)<=bitin;
		elsif arg_id="0001" then
			lutv2(4)<=bitin;
		elsif arg_id="0010" then
			lutv3(4)<=bitin;
		elsif arg_id="0011" then
			lutv4(4)<=bitin;
		elsif arg_id="0100" then
			lutv5(4)<=bitin;
		elsif arg_id="0101" then
			lutv6(4)<=bitin;
		elsif arg_id="0110" then
			lutv7(4)<=bitin;
		elsif arg_id="0111" then
			lutv8(4)<=bitin;
		elsif arg_id="1000" then
			lutv9(4)<=bitin;
		elsif arg_id="1001" then
			lutv10(4)<=bitin;
		elsif arg_id="1010" then
			lutv11(4)<=bitin;
		else
			lutv12(4)<=bitin;
		end if;
	elsif iter_id="1000" then
		if arg_id="0000" then
			lutv1(3)<=bitin;
		elsif arg_id="0001" then
			lutv2(3)<=bitin;
		elsif arg_id="0010" then
			lutv3(3)<=bitin;
		elsif arg_id="0011" then
			lutv4(3)<=bitin;
		elsif arg_id="0100" then
			lutv5(3)<=bitin;
		elsif arg_id="0101" then
			lutv6(3)<=bitin;
		elsif arg_id="0110" then
			lutv7(3)<=bitin;
		elsif arg_id="0111" then
			lutv8(3)<=bitin;
		elsif arg_id="1000" then
			lutv9(3)<=bitin;
		elsif arg_id="1001" then
			lutv10(3)<=bitin;
		elsif arg_id="1010" then
			lutv11(3)<=bitin;
		else
			lutv12(3)<=bitin;
		end if;
	elsif iter_id="1001" then
		if arg_id="0000" then
			lutv1(2)<=bitin;
		elsif arg_id="0001" then
			lutv2(2)<=bitin;
		elsif arg_id="0010" then
			lutv3(2)<=bitin;
		elsif arg_id="0011" then
			lutv4(2)<=bitin;
		elsif arg_id="0100" then
			lutv5(2)<=bitin;
		elsif arg_id="0101" then
			lutv6(2)<=bitin;
		elsif arg_id="0110" then
			lutv7(2)<=bitin;
		elsif arg_id="0111" then
			lutv8(2)<=bitin;
		elsif arg_id="1000" then
			lutv9(2)<=bitin;
		elsif arg_id="1001" then
			lutv10(2)<=bitin;
		elsif arg_id="1010" then
			lutv11(2)<=bitin;
		else
			lutv12(2)<=bitin;
		end if;
	elsif iter_id="1010" then
		if arg_id="0000" then
			lutv1(1)<=bitin;
		elsif arg_id="0001" then
			lutv2(1)<=bitin;
		elsif arg_id="0010" then
			lutv3(1)<=bitin;
		elsif arg_id="0011" then
			lutv4(1)<=bitin;
		elsif arg_id="0100" then
			lutv5(1)<=bitin;
		elsif arg_id="0101" then
			lutv6(1)<=bitin;
		elsif arg_id="0110" then
			lutv7(1)<=bitin;
		elsif arg_id="0111" then
			lutv8(1)<=bitin;
		elsif arg_id="1000" then
			lutv9(1)<=bitin;
		elsif arg_id="1001" then
			lutv10(1)<=bitin;
		elsif arg_id="1010" then
			lutv11(1)<=bitin;
		else
			lutv12(1)<=bitin;
		end if;
	elsif iter_id="1011" then
		if arg_id="0000" then
			lutv1(0)<=bitin;
		elsif arg_id="0001" then
			lutv2(0)<=bitin;
		elsif arg_id="0010" then
			lutv3(0)<=bitin;
		elsif arg_id="0011" then
			lutv4(0)<=bitin;
		elsif arg_id="0100" then
			lutv5(0)<=bitin;
		elsif arg_id="0101" then
			lutv6(0)<=bitin;
		elsif arg_id="0110" then
			lutv7(0)<=bitin;
		elsif arg_id="0111" then
			lutv8(0)<=bitin;
		elsif arg_id="1000" then
			lutv9(0)<=bitin;
		elsif arg_id="1001" then
			lutv10(0)<=bitin;
		elsif arg_id="1010" then
			lutv11(0)<=bitin;
		else
			lutv12(0)<=bitin;
		end if;
	end if;
	end if;
end process;
	
	
MUX12to1_11_P: MUX12to1_11 Port Map
(
  sel => arg_id, 
  val1 => lutv1,
  val2 => lutv2,
  val3 => lutv3,
  val4 => lutv4,
  val5 => lutv5,
  val6 => lutv6,
  val7 => lutv7,
  val8 => lutv8,
  val9 => lutv9,
  val10 => lutv10,
  val11 => lutv11,
  val12 => lutv12,
  val_o => lut_f
);
			
SHFT: shift_reg_11b_10c Port Map
(
 clk => clk, 
 d => lut_f, 
 q =>lut_addr_11 
);

end Behavioral;

