--------------------------------------------------------------------------------
-- Copyright (c) 1995-2008 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____
--  /   /\/   /
-- /___/  \  /    Vendor: Xilinx
-- \   \   \/     Version: K.39
--  \   \         Application: netgen
--  /   /         Filename: shift_reg_12b_11c.vhd
-- /___/   /\     Timestamp: Sun May 16 14:52:59 2010
-- \   \  /  \ 
--  \___\/\___\
--             
-- Command	: -intstyle ise -w -sim -ofmt vhdl C:\EAU\coregenVIRTEX4_LX200T\tmp\_cg\shift_reg_12b_11c.ngc C:\EAU\coregenVIRTEX4_LX200T\tmp\_cg\shift_reg_12b_11c.vhd 
-- Device	: 4vlx200ff1513-11
-- Input file	: C:/EAU/coregenVIRTEX4_LX200T/tmp/_cg/shift_reg_12b_11c.ngc
-- Output file	: C:/EAU/coregenVIRTEX4_LX200T/tmp/_cg/shift_reg_12b_11c.vhd
-- # of Entities	: 1
-- Design Name	: shift_reg_12b_11c
-- Xilinx	: C:\Xilinx\10.1\ISE
--             
-- Purpose:    
--     This VHDL netlist is a verification model and uses simulation 
--     primitives which may not represent the true implementation of the 
--     device, however the netlist is functionally correct and should not 
--     be modified. This file cannot be synthesized and should only be used 
--     with supported simulation tools.
--             
-- Reference:  
--     Development System Reference Guide, Chapter 23
--     Synthesis and Simulation Design Guide, Chapter 6
--             
--------------------------------------------------------------------------------


-- synthesis translate_off
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;
use UNISIM.VPKG.ALL;

entity shift_reg_12b_11c is
  port (
    clk : in STD_LOGIC := 'X'; 
    d : in STD_LOGIC_VECTOR ( 11 downto 0 ); 
    q : out STD_LOGIC_VECTOR ( 11 downto 0 ) 
  );
end shift_reg_12b_11c;

architecture STRUCTURE of shift_reg_12b_11c is
  signal BU2_sclr : STD_LOGIC; 
  signal BU2_sset : STD_LOGIC; 
  signal BU2_sinit : STD_LOGIC; 
  signal BU2_ainit : STD_LOGIC; 
  signal BU2_aclr : STD_LOGIC; 
  signal BU2_ce : STD_LOGIC; 
  signal BU2_aset : STD_LOGIC; 
  signal BU2_U0_Mshreg_q_10_38 : STD_LOGIC; 
  signal BU2_U0_Mshreg_q_9_37 : STD_LOGIC; 
  signal BU2_U0_Mshreg_q_11_36 : STD_LOGIC; 
  signal BU2_U0_Mshreg_q_7_35 : STD_LOGIC; 
  signal BU2_U0_Mshreg_q_6_34 : STD_LOGIC; 
  signal BU2_U0_Mshreg_q_8_33 : STD_LOGIC; 
  signal BU2_U0_Mshreg_q_4_32 : STD_LOGIC; 
  signal BU2_U0_Mshreg_q_3_31 : STD_LOGIC; 
  signal BU2_U0_Mshreg_q_5_30 : STD_LOGIC; 
  signal BU2_U0_Mshreg_q_1_29 : STD_LOGIC; 
  signal BU2_U0_Mshreg_q_0_28 : STD_LOGIC; 
  signal BU2_U0_Mshreg_q_2_27 : STD_LOGIC; 
  signal BU2_U0_N1 : STD_LOGIC; 
  signal BU2_U0_N0 : STD_LOGIC; 
  signal NLW_VCC_P_UNCONNECTED : STD_LOGIC; 
  signal NLW_GND_G_UNCONNECTED : STD_LOGIC; 
  signal d_2 : STD_LOGIC_VECTOR ( 11 downto 0 ); 
  signal q_3 : STD_LOGIC_VECTOR ( 11 downto 0 ); 
  signal BU2_a : STD_LOGIC_VECTOR ( 3 downto 0 ); 
begin
  d_2(11) <= d(11);
  d_2(10) <= d(10);
  d_2(9) <= d(9);
  d_2(8) <= d(8);
  d_2(7) <= d(7);
  d_2(6) <= d(6);
  d_2(5) <= d(5);
  d_2(4) <= d(4);
  d_2(3) <= d(3);
  d_2(2) <= d(2);
  d_2(1) <= d(1);
  d_2(0) <= d(0);
  q(11) <= q_3(11);
  q(10) <= q_3(10);
  q(9) <= q_3(9);
  q(8) <= q_3(8);
  q(7) <= q_3(7);
  q(6) <= q_3(6);
  q(5) <= q_3(5);
  q(4) <= q_3(4);
  q(3) <= q_3(3);
  q(2) <= q_3(2);
  q(1) <= q_3(1);
  q(0) <= q_3(0);
  VCC_0 : VCC
    port map (
      P => NLW_VCC_P_UNCONNECTED
    );
  GND_1 : GND
    port map (
      G => NLW_GND_G_UNCONNECTED
    );
  BU2_U0_q_10 : FD
    generic map(
      INIT => '0'
    )
    port map (
      C => clk,
      D => BU2_U0_Mshreg_q_10_38,
      Q => q_3(10)
    );
  BU2_U0_Mshreg_q_10 : SRL16
    generic map(
      INIT => X"0000"
    )
    port map (
      A0 => BU2_U0_N1,
      A1 => BU2_U0_N0,
      A2 => BU2_U0_N0,
      A3 => BU2_U0_N1,
      CLK => clk,
      D => d_2(10),
      Q => BU2_U0_Mshreg_q_10_38
    );
  BU2_U0_q_9 : FD
    generic map(
      INIT => '0'
    )
    port map (
      C => clk,
      D => BU2_U0_Mshreg_q_9_37,
      Q => q_3(9)
    );
  BU2_U0_Mshreg_q_9 : SRL16
    generic map(
      INIT => X"0000"
    )
    port map (
      A0 => BU2_U0_N1,
      A1 => BU2_U0_N0,
      A2 => BU2_U0_N0,
      A3 => BU2_U0_N1,
      CLK => clk,
      D => d_2(9),
      Q => BU2_U0_Mshreg_q_9_37
    );
  BU2_U0_q_11 : FD
    generic map(
      INIT => '0'
    )
    port map (
      C => clk,
      D => BU2_U0_Mshreg_q_11_36,
      Q => q_3(11)
    );
  BU2_U0_Mshreg_q_11 : SRL16
    generic map(
      INIT => X"0000"
    )
    port map (
      A0 => BU2_U0_N1,
      A1 => BU2_U0_N0,
      A2 => BU2_U0_N0,
      A3 => BU2_U0_N1,
      CLK => clk,
      D => d_2(11),
      Q => BU2_U0_Mshreg_q_11_36
    );
  BU2_U0_q_7 : FD
    generic map(
      INIT => '0'
    )
    port map (
      C => clk,
      D => BU2_U0_Mshreg_q_7_35,
      Q => q_3(7)
    );
  BU2_U0_Mshreg_q_7 : SRL16
    generic map(
      INIT => X"0000"
    )
    port map (
      A0 => BU2_U0_N1,
      A1 => BU2_U0_N0,
      A2 => BU2_U0_N0,
      A3 => BU2_U0_N1,
      CLK => clk,
      D => d_2(7),
      Q => BU2_U0_Mshreg_q_7_35
    );
  BU2_U0_q_6 : FD
    generic map(
      INIT => '0'
    )
    port map (
      C => clk,
      D => BU2_U0_Mshreg_q_6_34,
      Q => q_3(6)
    );
  BU2_U0_Mshreg_q_6 : SRL16
    generic map(
      INIT => X"0000"
    )
    port map (
      A0 => BU2_U0_N1,
      A1 => BU2_U0_N0,
      A2 => BU2_U0_N0,
      A3 => BU2_U0_N1,
      CLK => clk,
      D => d_2(6),
      Q => BU2_U0_Mshreg_q_6_34
    );
  BU2_U0_q_8 : FD
    generic map(
      INIT => '0'
    )
    port map (
      C => clk,
      D => BU2_U0_Mshreg_q_8_33,
      Q => q_3(8)
    );
  BU2_U0_Mshreg_q_8 : SRL16
    generic map(
      INIT => X"0000"
    )
    port map (
      A0 => BU2_U0_N1,
      A1 => BU2_U0_N0,
      A2 => BU2_U0_N0,
      A3 => BU2_U0_N1,
      CLK => clk,
      D => d_2(8),
      Q => BU2_U0_Mshreg_q_8_33
    );
  BU2_U0_q_4 : FD
    generic map(
      INIT => '0'
    )
    port map (
      C => clk,
      D => BU2_U0_Mshreg_q_4_32,
      Q => q_3(4)
    );
  BU2_U0_Mshreg_q_4 : SRL16
    generic map(
      INIT => X"0000"
    )
    port map (
      A0 => BU2_U0_N1,
      A1 => BU2_U0_N0,
      A2 => BU2_U0_N0,
      A3 => BU2_U0_N1,
      CLK => clk,
      D => d_2(4),
      Q => BU2_U0_Mshreg_q_4_32
    );
  BU2_U0_q_3 : FD
    generic map(
      INIT => '0'
    )
    port map (
      C => clk,
      D => BU2_U0_Mshreg_q_3_31,
      Q => q_3(3)
    );
  BU2_U0_Mshreg_q_3 : SRL16
    generic map(
      INIT => X"0000"
    )
    port map (
      A0 => BU2_U0_N1,
      A1 => BU2_U0_N0,
      A2 => BU2_U0_N0,
      A3 => BU2_U0_N1,
      CLK => clk,
      D => d_2(3),
      Q => BU2_U0_Mshreg_q_3_31
    );
  BU2_U0_q_5 : FD
    generic map(
      INIT => '0'
    )
    port map (
      C => clk,
      D => BU2_U0_Mshreg_q_5_30,
      Q => q_3(5)
    );
  BU2_U0_Mshreg_q_5 : SRL16
    generic map(
      INIT => X"0000"
    )
    port map (
      A0 => BU2_U0_N1,
      A1 => BU2_U0_N0,
      A2 => BU2_U0_N0,
      A3 => BU2_U0_N1,
      CLK => clk,
      D => d_2(5),
      Q => BU2_U0_Mshreg_q_5_30
    );
  BU2_U0_q_1 : FD
    generic map(
      INIT => '0'
    )
    port map (
      C => clk,
      D => BU2_U0_Mshreg_q_1_29,
      Q => q_3(1)
    );
  BU2_U0_Mshreg_q_1 : SRL16
    generic map(
      INIT => X"0000"
    )
    port map (
      A0 => BU2_U0_N1,
      A1 => BU2_U0_N0,
      A2 => BU2_U0_N0,
      A3 => BU2_U0_N1,
      CLK => clk,
      D => d_2(1),
      Q => BU2_U0_Mshreg_q_1_29
    );
  BU2_U0_q_0 : FD
    generic map(
      INIT => '0'
    )
    port map (
      C => clk,
      D => BU2_U0_Mshreg_q_0_28,
      Q => q_3(0)
    );
  BU2_U0_Mshreg_q_0 : SRL16
    generic map(
      INIT => X"0000"
    )
    port map (
      A0 => BU2_U0_N1,
      A1 => BU2_U0_N0,
      A2 => BU2_U0_N0,
      A3 => BU2_U0_N1,
      CLK => clk,
      D => d_2(0),
      Q => BU2_U0_Mshreg_q_0_28
    );
  BU2_U0_q_2 : FD
    generic map(
      INIT => '0'
    )
    port map (
      C => clk,
      D => BU2_U0_Mshreg_q_2_27,
      Q => q_3(2)
    );
  BU2_U0_Mshreg_q_2 : SRL16
    generic map(
      INIT => X"0000"
    )
    port map (
      A0 => BU2_U0_N1,
      A1 => BU2_U0_N0,
      A2 => BU2_U0_N0,
      A3 => BU2_U0_N1,
      CLK => clk,
      D => d_2(2),
      Q => BU2_U0_Mshreg_q_2_27
    );
  BU2_U0_XST_VCC : VCC
    port map (
      P => BU2_U0_N1
    );
  BU2_U0_XST_GND : GND
    port map (
      G => BU2_U0_N0
    );

end STRUCTURE;

-- synthesis translate_on
