--------------------------------------------------------------------------------
-- Copyright (c) 1995-2008 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____
--  /   /\/   /
-- /___/  \  /    Vendor: Xilinx
-- \   \   \/     Version: K.39
--  \   \         Application: netgen
--  /   /         Filename: shift_reg_6b_11c.vhd
-- /___/   /\     Timestamp: Wed Apr 07 17:29:02 2010
-- \   \  /  \ 
--  \___\/\___\
--             
-- Command	: -intstyle ise -w -sim -ofmt vhdl C:\EAU\coregen\tmp\_cg\shift_reg_6b_11c.ngc C:\EAU\coregen\tmp\_cg\shift_reg_6b_11c.vhd 
-- Device	: 5vsx95tff1136-2
-- Input file	: C:/EAU/coregen/tmp/_cg/shift_reg_6b_11c.ngc
-- Output file	: C:/EAU/coregen/tmp/_cg/shift_reg_6b_11c.vhd
-- # of Entities	: 1
-- Design Name	: shift_reg_6b_11c
-- Xilinx	: C:\Xilinx\10.1\ISE
--             
-- Purpose:    
--     This VHDL netlist is a verification model and uses simulation 
--     primitives which may not represent the true implementation of the 
--     device, however the netlist is functionally correct and should not 
--     be modified. This file cannot be synthesized and should only be used 
--     with supported simulation tools.
--             
-- Reference:  
--     Development System Reference Guide, Chapter 23
--     Synthesis and Simulation Design Guide, Chapter 6
--             
--------------------------------------------------------------------------------


-- synthesis translate_off
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;
use UNISIM.VPKG.ALL;

entity shift_reg_6b_11c is
  port (
    clk : in STD_LOGIC := 'X'; 
    d : in STD_LOGIC_VECTOR ( 5 downto 0 ); 
    q : out STD_LOGIC_VECTOR ( 5 downto 0 ) 
  );
end shift_reg_6b_11c;

architecture STRUCTURE of shift_reg_6b_11c is
  signal BU2_sclr : STD_LOGIC; 
  signal BU2_sset : STD_LOGIC; 
  signal BU2_sinit : STD_LOGIC; 
  signal BU2_ainit : STD_LOGIC; 
  signal BU2_aclr : STD_LOGIC; 
  signal BU2_ce : STD_LOGIC; 
  signal BU2_aset : STD_LOGIC; 
  signal BU2_U0_Mshreg_q_4_20 : STD_LOGIC; 
  signal BU2_U0_Mshreg_q_3_19 : STD_LOGIC; 
  signal BU2_U0_Mshreg_q_5_18 : STD_LOGIC; 
  signal BU2_U0_Mshreg_q_1_17 : STD_LOGIC; 
  signal BU2_U0_Mshreg_q_0_16 : STD_LOGIC; 
  signal BU2_U0_Mshreg_q_2_15 : STD_LOGIC; 
  signal BU2_U0_N1 : STD_LOGIC; 
  signal BU2_U0_N0 : STD_LOGIC; 
  signal NLW_VCC_P_UNCONNECTED : STD_LOGIC; 
  signal NLW_GND_G_UNCONNECTED : STD_LOGIC; 
  signal NLW_BU2_U0_Mshreg_q_4_Q15_UNCONNECTED : STD_LOGIC; 
  signal NLW_BU2_U0_Mshreg_q_3_Q15_UNCONNECTED : STD_LOGIC; 
  signal NLW_BU2_U0_Mshreg_q_5_Q15_UNCONNECTED : STD_LOGIC; 
  signal NLW_BU2_U0_Mshreg_q_1_Q15_UNCONNECTED : STD_LOGIC; 
  signal NLW_BU2_U0_Mshreg_q_0_Q15_UNCONNECTED : STD_LOGIC; 
  signal NLW_BU2_U0_Mshreg_q_2_Q15_UNCONNECTED : STD_LOGIC; 
  signal d_2 : STD_LOGIC_VECTOR ( 5 downto 0 ); 
  signal q_3 : STD_LOGIC_VECTOR ( 5 downto 0 ); 
  signal BU2_a : STD_LOGIC_VECTOR ( 3 downto 0 ); 
begin
  d_2(5) <= d(5);
  d_2(4) <= d(4);
  d_2(3) <= d(3);
  d_2(2) <= d(2);
  d_2(1) <= d(1);
  d_2(0) <= d(0);
  q(5) <= q_3(5);
  q(4) <= q_3(4);
  q(3) <= q_3(3);
  q(2) <= q_3(2);
  q(1) <= q_3(1);
  q(0) <= q_3(0);
  VCC_0 : VCC
    port map (
      P => NLW_VCC_P_UNCONNECTED
    );
  GND_1 : GND
    port map (
      G => NLW_GND_G_UNCONNECTED
    );
  BU2_U0_q_4 : FDE
    generic map(
      INIT => '0'
    )
    port map (
      C => clk,
      CE => BU2_U0_N1,
      D => BU2_U0_Mshreg_q_4_20,
      Q => q_3(4)
    );
  BU2_U0_Mshreg_q_4 : SRLC16E
    generic map(
      INIT => X"0000"
    )
    port map (
      A0 => BU2_U0_N1,
      A1 => BU2_U0_N0,
      A2 => BU2_U0_N0,
      A3 => BU2_U0_N1,
      CE => BU2_U0_N1,
      CLK => clk,
      D => d_2(4),
      Q => BU2_U0_Mshreg_q_4_20,
      Q15 => NLW_BU2_U0_Mshreg_q_4_Q15_UNCONNECTED
    );
  BU2_U0_q_3 : FDE
    generic map(
      INIT => '0'
    )
    port map (
      C => clk,
      CE => BU2_U0_N1,
      D => BU2_U0_Mshreg_q_3_19,
      Q => q_3(3)
    );
  BU2_U0_Mshreg_q_3 : SRLC16E
    generic map(
      INIT => X"0000"
    )
    port map (
      A0 => BU2_U0_N1,
      A1 => BU2_U0_N0,
      A2 => BU2_U0_N0,
      A3 => BU2_U0_N1,
      CE => BU2_U0_N1,
      CLK => clk,
      D => d_2(3),
      Q => BU2_U0_Mshreg_q_3_19,
      Q15 => NLW_BU2_U0_Mshreg_q_3_Q15_UNCONNECTED
    );
  BU2_U0_q_5 : FDE
    generic map(
      INIT => '0'
    )
    port map (
      C => clk,
      CE => BU2_U0_N1,
      D => BU2_U0_Mshreg_q_5_18,
      Q => q_3(5)
    );
  BU2_U0_Mshreg_q_5 : SRLC16E
    generic map(
      INIT => X"0000"
    )
    port map (
      A0 => BU2_U0_N1,
      A1 => BU2_U0_N0,
      A2 => BU2_U0_N0,
      A3 => BU2_U0_N1,
      CE => BU2_U0_N1,
      CLK => clk,
      D => d_2(5),
      Q => BU2_U0_Mshreg_q_5_18,
      Q15 => NLW_BU2_U0_Mshreg_q_5_Q15_UNCONNECTED
    );
  BU2_U0_q_1 : FDE
    generic map(
      INIT => '0'
    )
    port map (
      C => clk,
      CE => BU2_U0_N1,
      D => BU2_U0_Mshreg_q_1_17,
      Q => q_3(1)
    );
  BU2_U0_Mshreg_q_1 : SRLC16E
    generic map(
      INIT => X"0000"
    )
    port map (
      A0 => BU2_U0_N1,
      A1 => BU2_U0_N0,
      A2 => BU2_U0_N0,
      A3 => BU2_U0_N1,
      CE => BU2_U0_N1,
      CLK => clk,
      D => d_2(1),
      Q => BU2_U0_Mshreg_q_1_17,
      Q15 => NLW_BU2_U0_Mshreg_q_1_Q15_UNCONNECTED
    );
  BU2_U0_q_0 : FDE
    generic map(
      INIT => '0'
    )
    port map (
      C => clk,
      CE => BU2_U0_N1,
      D => BU2_U0_Mshreg_q_0_16,
      Q => q_3(0)
    );
  BU2_U0_Mshreg_q_0 : SRLC16E
    generic map(
      INIT => X"0000"
    )
    port map (
      A0 => BU2_U0_N1,
      A1 => BU2_U0_N0,
      A2 => BU2_U0_N0,
      A3 => BU2_U0_N1,
      CE => BU2_U0_N1,
      CLK => clk,
      D => d_2(0),
      Q => BU2_U0_Mshreg_q_0_16,
      Q15 => NLW_BU2_U0_Mshreg_q_0_Q15_UNCONNECTED
    );
  BU2_U0_q_2 : FDE
    generic map(
      INIT => '0'
    )
    port map (
      C => clk,
      CE => BU2_U0_N1,
      D => BU2_U0_Mshreg_q_2_15,
      Q => q_3(2)
    );
  BU2_U0_Mshreg_q_2 : SRLC16E
    generic map(
      INIT => X"0000"
    )
    port map (
      A0 => BU2_U0_N1,
      A1 => BU2_U0_N0,
      A2 => BU2_U0_N0,
      A3 => BU2_U0_N1,
      CE => BU2_U0_N1,
      CLK => clk,
      D => d_2(2),
      Q => BU2_U0_Mshreg_q_2_15,
      Q15 => NLW_BU2_U0_Mshreg_q_2_Q15_UNCONNECTED
    );
  BU2_U0_XST_VCC : VCC
    port map (
      P => BU2_U0_N1
    );
  BU2_U0_XST_GND : GND
    port map (
      G => BU2_U0_N0
    );

end STRUCTURE;

-- synthesis translate_on
